package com.example;

import com.example.WorkflowModel;
import org.kie.api.definition.process.Process;
import org.jbpm.ruleflow.core.RuleFlowProcessFactory;
import org.jbpm.process.core.datatype.impl.type.ObjectDataType;
import org.drools.core.util.KieFunctions;

@javax.enterprise.context.ApplicationScoped()
@javax.inject.Named("workflow")
@io.quarkus.runtime.Startup()
public class WorkflowProcess extends org.kie.kogito.process.impl.AbstractProcess<com.example.WorkflowModel> {

    public WorkflowProcess(org.kie.kogito.app.Application app, org.kie.kogito.correlation.CorrelationService correlations) {
        this(app, correlations, new org.kie.kogito.handlers.NodeExceptionHandler_execute_4_Handler(), new org.kie.kogito.handlers.CatchAllExceptionHandler_execute_9_Handler(), new org.kie.kogito.handlers.Node_execute_5_Handler());
    }

    @javax.inject.Inject()
    public WorkflowProcess(org.kie.kogito.app.Application app, org.kie.kogito.correlation.CorrelationService correlations, org.kie.kogito.handlers.NodeExceptionHandler_execute_4_Handler nodeExceptionHandler_execute_4_Handler, org.kie.kogito.handlers.CatchAllExceptionHandler_execute_9_Handler catchAllExceptionHandler_execute_9_Handler, org.kie.kogito.handlers.Node_execute_5_Handler node_execute_5_Handler) {
        super(app, java.util.Arrays.asList(nodeExceptionHandler_execute_4_Handler, catchAllExceptionHandler_execute_9_Handler, node_execute_5_Handler), correlations);
        activate();
    }

    public WorkflowProcess() {
    }

    @Override()
    public com.example.WorkflowProcessInstance createInstance(com.example.WorkflowModel value) {
        return new com.example.WorkflowProcessInstance(this, value, this.createProcessRuntime());
    }

    public com.example.WorkflowProcessInstance createInstance(java.lang.String businessKey, com.example.WorkflowModel value) {
        return new com.example.WorkflowProcessInstance(this, value, businessKey, this.createProcessRuntime());
    }

    public com.example.WorkflowProcessInstance createInstance(java.lang.String businessKey, org.kie.kogito.correlation.CompositeCorrelation correlation, com.example.WorkflowModel value) {
        return new com.example.WorkflowProcessInstance(this, value, businessKey, this.createProcessRuntime(), correlation);
    }

    @Override()
    public com.example.WorkflowModel createModel() {
        return new com.example.WorkflowModel();
    }

    public com.example.WorkflowProcessInstance createInstance(org.kie.kogito.Model value) {
        return this.createInstance((com.example.WorkflowModel) value);
    }

    public com.example.WorkflowProcessInstance createInstance(java.lang.String businessKey, org.kie.kogito.Model value) {
        return this.createInstance(businessKey, (com.example.WorkflowModel) value);
    }

    public com.example.WorkflowProcessInstance createInstance(org.kie.api.runtime.process.WorkflowProcessInstance wpi) {
        return new com.example.WorkflowProcessInstance(this, this.createModel(), this.createProcessRuntime(), wpi);
    }

    public com.example.WorkflowProcessInstance createReadOnlyInstance(org.kie.api.runtime.process.WorkflowProcessInstance wpi) {
        return new com.example.WorkflowProcessInstance(this, this.createModel(), wpi);
    }

    protected org.kie.api.definition.process.Process process() {
        RuleFlowProcessFactory factory = RuleFlowProcessFactory.createProcess("workflow", true);
        factory.variable("exception", org.jbpm.process.core.datatype.DataTypeResolver.fromClass(java.lang.Throwable.class), null, "customTags", null);
        factory.name("workflow");
        factory.packageName("com.example");
        factory.dynamic(false);
        factory.version("1.0");
        factory.type("BPMN");
        factory.visibility("Public");
        factory.metaData("TargetNamespace", "http://www.omg.org/bpmn20");
        org.jbpm.ruleflow.core.factory.StartNodeFactory<?> startNode1 = factory.startNode(1);
        startNode1.name("Start");
        startNode1.interrupting(true);
        startNode1.metaData("UniqueId", "_1E33CA79-D4A3-4BAD-8C46-8A1E773D87E5");
        startNode1.metaData("x", 251);
        startNode1.metaData("width", 56);
        startNode1.metaData("y", 72);
        startNode1.metaData("height", 56);
        startNode1.done();
        startNode1.timer("P0DT0H0M5S", null, null, 1);
        org.jbpm.ruleflow.core.factory.EndNodeFactory<?> endNode2 = factory.endNode(2);
        endNode2.name("End");
        endNode2.terminate(false);
        endNode2.metaData("UniqueId", "_AF4970F8-1DC8-4CE2-9B76-BDEE3ADA0AFE");
        endNode2.metaData("x", 687);
        endNode2.metaData("width", 56);
        endNode2.metaData("y", 72);
        endNode2.metaData("height", 56);
        endNode2.done();
        org.jbpm.ruleflow.core.factory.EndNodeFactory<?> endNode3 = factory.endNode(3);
        endNode3.name("End");
        endNode3.terminate(false);
        endNode3.metaData("UniqueId", "_C9F9B69E-C2CB-4BC3-9B78-EE652A377E39");
        endNode3.metaData("x", 693);
        endNode3.metaData("width", 56);
        endNode3.metaData("y", 383);
        endNode3.metaData("height", 56);
        endNode3.done();
        org.jbpm.ruleflow.core.factory.WorkItemNodeFactory<?> workItemNode4 = factory.workItemNode(4);
        workItemNode4.name("Handle Node Exception");
        workItemNode4.workName("com.reproducer.NodeExceptionHandler_execute_4_Handler");
        workItemNode4.workParameter("NodeName", "Handle Node Exception");
        workItemNode4.workParameter("Interface", "com.reproducer.NodeExceptionHandler");
        workItemNode4.workParameter("Operation", "execute");
        workItemNode4.workParameter("interfaceImplementationRef", "com.reproducer.NodeExceptionHandler");
        workItemNode4.workParameter("operationImplementationRef", "execute");
        workItemNode4.workParameter("implementation", "Java");
        workItemNode4.done();
        workItemNode4.metaData("UniqueId", "_56012744-B9B0-46D4-A421-8B084495A9DF");
        workItemNode4.metaData("Implementation", "Java");
        workItemNode4.metaData("elementname", "Handle Node Exception");
        workItemNode4.metaData("Type", "Service Task");
        workItemNode4.metaData("OperationRef", "_56012744-B9B0-46D4-A421-8B084495A9DF_ServiceOperation");
        workItemNode4.metaData("x", 459);
        workItemNode4.metaData("width", 154);
        workItemNode4.metaData("y", 360);
        workItemNode4.metaData("height", 102);
        org.jbpm.ruleflow.core.factory.WorkItemNodeFactory<?> workItemNode5 = factory.workItemNode(5);
        workItemNode5.name("Node");
        workItemNode5.workName("com.reproducer.Node_execute_5_Handler");
        workItemNode5.workParameter("NodeName", "Node");
        workItemNode5.workParameter("Interface", "com.reproducer.Node");
        workItemNode5.workParameter("Operation", "execute");
        workItemNode5.workParameter("interfaceImplementationRef", "com.reproducer.Node");
        workItemNode5.workParameter("operationImplementationRef", "execute");
        workItemNode5.workParameter("implementation", "Java");
        workItemNode5.done();
        workItemNode5.metaData("UniqueId", "_2FB5852D-B1B4-4425-9F84-2788F11A4C4B");
        workItemNode5.metaData("Implementation", "Java");
        workItemNode5.metaData("elementname", "Node");
        workItemNode5.metaData("Type", "Service Task");
        workItemNode5.metaData("OperationRef", "_2FB5852D-B1B4-4425-9F84-2788F11A4C4B_ServiceOperation");
        workItemNode5.metaData("x", 453);
        workItemNode5.metaData("width", 154);
        workItemNode5.metaData("y", 49);
        workItemNode5.metaData("height", 102);
        org.jbpm.ruleflow.core.factory.EventSubProcessNodeFactory<?> eventSubProcessNode6 = factory.eventSubProcessNode(6);
        eventSubProcessNode6.name("Error Sub Process");
        eventSubProcessNode6.metaData("UniqueId", "_32186844-2E93-4615-A62F-29DDE38C59F0");
        eventSubProcessNode6.metaData("elementname", "Error Sub Process");
        eventSubProcessNode6.metaData("x", 209);
        eventSubProcessNode6.metaData("width", 653);
        eventSubProcessNode6.metaData("y", 601);
        eventSubProcessNode6.metaData("height", 253);
        eventSubProcessNode6.variable("exception", org.jbpm.process.core.datatype.DataTypeResolver.fromClass(java.lang.Throwable.class), null, "customTags", null);
        eventSubProcessNode6.keepActive(true);
        eventSubProcessNode6.event("Error-java.lang.Throwable");
        eventSubProcessNode6.autoComplete(true);
        org.jbpm.ruleflow.core.factory.StartNodeFactory<?> startNode7 = eventSubProcessNode6.startNode(7);
        startNode7.name("Start");
        startNode7.interrupting(true);
        startNode7.mapDataOutputAssociation(new org.jbpm.workflow.core.impl.DataAssociation(java.util.Arrays.asList(new org.jbpm.workflow.core.impl.DataDefinition("_9D257E18-D8C6-424E-896F-29AEADE9F921_incomingExceptionOutputX", "incomingException", "java.lang.Throwable", null)), new org.jbpm.workflow.core.impl.DataDefinition("exception", "exception", "java.lang.Object", null), null, null));
        startNode7.metaData("TriggerMapping", "exception");
        startNode7.metaData("FaultCode", "java.lang.Throwable");
        startNode7.metaData("UniqueId", "_9D257E18-D8C6-424E-896F-29AEADE9F921");
        startNode7.metaData("TriggerType", "Signal");
        startNode7.metaData("TriggerRef", "java.lang.Throwable");
        startNode7.metaData("x", 42);
        startNode7.metaData("width", 56);
        startNode7.metaData("y", 116);
        startNode7.metaData("MappingVariable", "exception");
        startNode7.metaData("TriggerMappingInput", "incomingException");
        startNode7.metaData("MessageType", "java.lang.Throwable");
        startNode7.metaData("height", 56);
        startNode7.done();
        startNode7.trigger("java.lang.Throwable", java.util.Arrays.asList(new org.jbpm.workflow.core.impl.DataAssociation(java.util.Arrays.asList(new org.jbpm.workflow.core.impl.DataDefinition("_9D257E18-D8C6-424E-896F-29AEADE9F921_incomingExceptionOutputX", "incomingException", "java.lang.Throwable", null)), new org.jbpm.workflow.core.impl.DataDefinition("exception", "exception", "java.lang.Object", null), null, null)));
        org.jbpm.ruleflow.core.factory.EndNodeFactory<?> endNode8 = eventSubProcessNode6.endNode(8);
        endNode8.name("End");
        endNode8.terminate(false);
        endNode8.metaData("UniqueId", "_AD173F49-8335-4721-8705-73F3ACCF646E");
        endNode8.metaData("x", 478);
        endNode8.metaData("width", 56);
        endNode8.metaData("y", 116);
        endNode8.metaData("height", 56);
        endNode8.done();
        org.jbpm.ruleflow.core.factory.WorkItemNodeFactory<?> workItemNode9 = eventSubProcessNode6.workItemNode(9);
        workItemNode9.name("Catch All Exception Handler");
        workItemNode9.workName("com.reproducer.CatchAllExceptionHandler_execute_9_Handler");
        workItemNode9.workParameter("NodeName", "Catch All Exception Handler");
        workItemNode9.workParameter("Interface", "com.reproducer.CatchAllExceptionHandler");
        workItemNode9.workParameter("Operation", "execute");
        workItemNode9.workParameter("interfaceImplementationRef", "com.reproducer.CatchAllExceptionHandler");
        workItemNode9.workParameter("operationImplementationRef", "execute");
        workItemNode9.workParameter("implementation", "Java");
        workItemNode9.mapDataInputAssociation(new org.jbpm.workflow.core.impl.DataAssociation(java.util.Arrays.asList(new org.jbpm.workflow.core.impl.DataDefinition("exception", "exception", "java.lang.Object", null)), new org.jbpm.workflow.core.impl.DataDefinition("_2B45F8FD-E678-4EC5-B7C6-BA8D7959EA88_throwableInputX", "throwable", "java.lang.Throwable", null), null, null));
        workItemNode9.done();
        workItemNode9.metaData("UniqueId", "_2B45F8FD-E678-4EC5-B7C6-BA8D7959EA88");
        workItemNode9.metaData("Implementation", "Java");
        workItemNode9.metaData("elementname", "Catch All Exception Handler");
        workItemNode9.metaData("Type", "Service Task");
        workItemNode9.metaData("OperationRef", "_2B45F8FD-E678-4EC5-B7C6-BA8D7959EA88_ServiceOperation");
        workItemNode9.metaData("x", 244);
        workItemNode9.metaData("width", 154);
        workItemNode9.metaData("y", 93);
        workItemNode9.metaData("height", 102);
        eventSubProcessNode6.connection(9, 8, "_7F25C628-1666-4355-9E33-B4A25E971C77");
        eventSubProcessNode6.connection(7, 9, "_A34A14D0-609D-4F75-A504-992E282C3035");
        eventSubProcessNode6.done();
        org.jbpm.ruleflow.core.factory.BoundaryEventNodeFactory<?> boundaryEventNode10 = factory.boundaryEventNode(10);
        boundaryEventNode10.name("NodeException");
        boundaryEventNode10.eventType("Error-_2FB5852D-B1B4-4425-9F84-2788F11A4C4B-com.reproducer.NodeException");
        boundaryEventNode10.attachedTo("_2FB5852D-B1B4-4425-9F84-2788F11A4C4B");
        boundaryEventNode10.scope(null);
        boundaryEventNode10.metaData("UniqueId", "_821CA191-729B-43EF-B736-47438E265F62");
        boundaryEventNode10.metaData("EventType", "error");
        boundaryEventNode10.metaData("ErrorStructureRef", null);
        boundaryEventNode10.metaData("elementname", "NodeException");
        boundaryEventNode10.metaData("ErrorEvent", "com.reproducer.NodeException");
        boundaryEventNode10.metaData("x", 508);
        boundaryEventNode10.metaData("width", 56);
        boundaryEventNode10.metaData("y", 123);
        boundaryEventNode10.metaData("AttachedTo", "_2FB5852D-B1B4-4425-9F84-2788F11A4C4B");
        boundaryEventNode10.metaData("HasErrorEvent", true);
        boundaryEventNode10.metaData("height", 56);
        boundaryEventNode10.done();
        factory.errorExceptionHandler("Error-java.lang.Throwable", "java.lang.Throwable", "exception");
        factory.errorExceptionHandler("Error-_2FB5852D-B1B4-4425-9F84-2788F11A4C4B-com.reproducer.NodeException", "com.reproducer.NodeException", null);
        factory.connection(5, 2, "_14A47BC4-070C-4B3A-B1C6-19B70F545137");
        factory.connection(4, 3, "_761C02B4-9243-4D6F-9151-E2E63C8233F9");
        factory.connection(10, 4, "_CEDCA676-B278-43FF-8C5A-F725DC0445AC");
        factory.connection(1, 5, "_54F7ED6C-B51B-485D-AC66-B6AC430D103B");
        factory.validate();
        return factory.getProcess();
    }
}
